; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive

; 

      m2m MACRO M1, M2
        push M2
        pop  M1
      ENDM

;     include files
;     ~~~~~~~~~~~~~
      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\Comctl32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\oleaut32.inc
      include \masm32\include\dialogs.inc
      include \masm32\macros\macros.asm

;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\Comctl32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\oleaut32.lib

      include filedlgs.asm

      DialogProc    PROTO :DWORD,:DWORD,:DWORD,:DWORD
      About         PROTO :DWORD,:DWORD
      AboutProc     PROTO :DWORD,:DWORD,:DWORD,:DWORD
      GetImage      PROTO :DWORD,:DWORD
      write_to_disk PROTO :DWORD,:DWORD,:DWORD

    .data?
        hWnd      dd ?
        hInstance dd ?

    .code

; 

start:

      mov hInstance, FUNC(GetModuleHandle,NULL)

      call main

      invoke ExitProcess,eax

; 

main proc

    Dialog "Get PE Image", \                ; caption
           "MS Sans Serif",8, \             ; font,pointsize
            WS_OVERLAPPED or \              ; styles for
            WS_SYSMENU or DS_CENTER, \      ; dialog window
            2, \                            ; number of controls
            50,50,200,120, \                ; x y co-ordinates
            1024                            ; memory buffer size

    DlgButton "Get PE File",WS_TABSTOP,135,10,50,13,IDOK
    DlgButton "Close",WS_TABSTOP,135,25,50,13,IDCANCEL

    CallModalDialog hInstance,0,DialogProc,NULL

    ret

main endp

; 

DialogProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL hDC   :DWORD
    LOCAL ps    :PAINTSTRUCT
    LOCAL rct   :RECT

    .if uMsg == WM_INITDIALOG
      invoke SendMessage,hWin,WM_SETICON,1,
                         FUNC(LoadIcon,NULL,IDI_ASTERISK)
      m2m hWnd, hWin    ; hWnd is GLOBAL in scope

      mov eax, 1
      ret

    .elseif uMsg == WM_PAINT
      invoke BeginPaint,hWin,ADDR ps
      mov hDC, eax
      invoke GetClientRect,hWin,ADDR rct

      invoke DrawEdge,hDC,ADDR rct,EDGE_ETCHED,BF_RECT
      invoke EndPaint,hWin,ADDR ps

    .elseif uMsg == WM_COMMAND
      .if wParam == IDOK
        mov szFileName[0], 0
        invoke GetFileName,hWnd,SADD("Get EXE file"),SADD("EXE Files",0,"*.exe",0,0)
        cmp szFileName[0], 0
        jne @F
        xor eax, eax
        ret
      @@:
        invoke GetImage,ADDR szFileName,400000h

      .elseif wParam == IDCANCEL
        jmp quit_dialog
      .endif

    .elseif uMsg == WM_CLOSE
      quit_dialog:
      invoke EndDialog,hWin,0

    .endif

    xor eax, eax
    ret

DialogProc endp

; 

write_to_disk proc lpName:DWORD,lpData:DWORD,fl:DWORD

; ----------------------------------------
; write_to_disk PROTO:DWORD,:DWORD,:DWORD
; ----------------------------------------

    LOCAL hOutput:DWORD
    LOCAL bw     :DWORD

    invoke CreateFile,lpName,GENERIC_WRITE,NULL,NULL,
                      CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
    mov hOutput, eax
    invoke WriteFile,hOutput,lpData,fl,ADDR bw,NULL
    invoke CloseHandle,hOutput

    mov eax, bw                 ; return written byte count
    ret

write_to_disk endp

; 

GetImage proc lpfname:DWORD, startaddress:DWORD

    LOCAL hFile     :DWORD
    LOCAL fl        :DWORD
    LOCAL bRead     :DWORD
    LOCAL hMem      :DWORD
    LOCAL hProc     :DWORD
    LOCAL bSize     :DWORD
    LOCAL bWritten  :DWORD

    LOCAL pri        :PROCESS_INFORMATION
    LOCAL sui        :STARTUPINFO

  ; ------------------------------
  ; create a handle for file read
  ; ------------------------------
    mov hFile, FUNC(CreateFile,lpfname,GENERIC_READ,0,NULL,OPEN_EXISTING,NULL,NULL) 
    mov fl, FUNC(GetFileSize,hFile,NULL)            ; get the file length
    lea eax, [eax+eax*4]                            ; multiply length by 5
    mov bSize, eax
    mov hMem, alloc(eax)                            ; allocate a buffer of that size

  ; ------------------------------------------
  ; fill memory buffer with "xxxx" characters
  ; ------------------------------------------
    push edi
    mov eax, "xxxx"
    mov edi, hMem
    mov ecx, bSize
    shr ecx, 2
    rep stosd
    pop edi

    invoke ReadFile,hFile,hMem,fl,ADDR bRead,NULL   ; read file into buffer
    invoke CloseHandle,hFile                        ; close the handle

  ; --------------------------------------------
  ; scan the first 1024 bytes for a PE signature
  ; --------------------------------------------
    invoke BinSearch,0,hMem,1024,SADD("PE",0,0),4
    cmp eax, -1
    jne @F
    invoke MessageBox,hWnd,SADD("Selected file is not a PE file"),
                           SADD("Incorrect EXE file type"),MB_OK
    ret
  @@:

    invoke CreateProcess,lpfname,NULL,NULL,NULL,FALSE,
                         DETACHED_PROCESS,NULL,NULL,ADDR sui,ADDR pri
    mov hProc, FUNC(OpenProcess,PROCESS_VM_READ,TRUE,pri.dwProcessId)
    invoke ReadProcessMemory,hProc,startaddress,hMem,bSize,ADDR bRead

  ; ---------------------------
  ; find the end of the buffer
  ; ---------------------------
    mov bWritten, FUNC(BinSearch,0,hMem,bSize,SADD("xxxxxxxxxxxx"),12)

    invoke SetForegroundWindow,hWnd ; bring this app back to the top

    mov szFileName[0], 0
    invoke SaveFileName,hWnd,SADD("Save Image As ..."),SADD("All Files",0,"*.*",0,0)
    cmp szFileName[0], 0
    je cleanup

  ; ----------------------------------------------------------
  ; write the image to a disk file at the loaded image length
  ; ----------------------------------------------------------
    invoke write_to_disk,ADDR szFileName,hMem,bWritten

    invoke MessageBox,hWnd,str$(eax),SADD("Bytes written to file"),MB_OK

  cleanup:
    invoke CloseHandle,hProc
    free hMem

    ret

GetImage endp

; 

end start
